-- Practica 2, primer quatrimestre: Concurs de castells
-- Programador: Sergio Blanco Cuaresma
-- Data: gener 2001
-- Resum:
--  Tenim un fitxer d'entrada anomenat "castells.txt", el qual conte
--  a cada linea un nom de colla, els castells que han fet (min.0 - max.5)
--  i si han (des)carregat. A partir d'aquestes dades haurem de calcular la puntuacio
--  de cada colla (3 millors castells) i guardarles al arxiu de sortida
--  anomenat "resultats.txt"
--------------------------------------------------------------------------------------

with ada.text_io; use Ada.Text_io;
procedure blanco_p2 is

package enter_io is new ada.text_io.integer_io(integer);use enter_io;

type IDENT_CASTELL is (dosde7, quatrede8, tresde8, dosde8f, cincde8, quatrede8a, quatrede9f, tresde9f, tresde8s, dosde9fm, pilarde8fm, cincde9f, quatrede9fa, dosde8, quatrede9, tresde10fm);
package castells_io is new ada.text_io.enumeration_io(IDENT_CASTELL); use castells_io;

type ident is array (0..4) of IDENT_CASTELL;
type accio is array(0..4) of character;

type CASTELL is record
    pdesc: natural;
    pcar: natural;
end record;

type LLISTA_CASTELLS is array (dosde7..tresde10fm) of CASTELL;

type NOMCOLLA is array (0..40) of character; -- Nom de la colla de 40 caracters mes els ':'

castells: LLISTA_CASTELLS;  -- Aqui guardarem les puntuacions
actuacio, resultat: file_type;  -- Arxius d'entrada i sortida respectivament
nom_colla: NOMCOLLA;  -- Guardarem el nom de la colla que estem tractant
ident_fet: ident;  -- Utilitzada per guardar els castells fets per 1 colla (maxim 5)
accio_feta: accio;  -- Utilitzada per guardar carregat (c) /descarregat (d) per cada castell fet
bucle: integer;
total, linea: natural;  -- total: puntuacio total, linea: linea actual que tractem, nomes
                        -- ens servira en cas d'error per indicar a on s'ha produit
llarg, incompleta, accio_erronea: exception;


---------------------------------------------------------
-- Introduim la taula predefinida amb la puntuacio     --
---------------------------------------------------------

procedure inic_puntuacio (castells: in out LLISTA_CASTELLS) is

begin
    -- Descarregat
    castells(dosde7).pdesc:=2280;
    castells(quatrede8).pdesc:=2940;
    castells(tresde8).pdesc:=3680;
    castells(dosde8f).pdesc:=4080;
    castells(cincde8).pdesc:=4940;
    castells(quatrede8a).pdesc:=5400;
    castells(quatrede9f).pdesc:=5880;
    castells(tresde9f).pdesc:=6380;
    castells(tresde8s).pdesc:=6900;
    castells(dosde9fm).pdesc:=8000;
    castells(pilarde8fm).pdesc:=8580;
    castells(cincde9f).pdesc:=9180;
    castells(quatrede9fa).pdesc:=9800;
    castells(dosde8).pdesc:=10440;
    castells(quatrede9).pdesc:=11780;
    castells(tresde10fm).pdesc:=13940;
    -- Carregat
    castells(dosde7).pcar:=2000;
    castells(quatrede8).pcar:=2620;
    castells(tresde8).pcar:=3320;
    castells(dosde8f).pcar:=3700;
    castells(cincde8).pcar:=4520;
    castells(quatrede8a).pcar:=4960;
    castells(quatrede9f).pcar:=5420;
    castells(tresde9f).pcar:=5900;
    castells(tresde8s).pcar:=6400;
    castells(dosde9fm).pcar:=7460;
    castells(pilarde8fm).pcar:=8020;
    castells(cincde9f).pcar:=8600;
    castells(quatrede9fa).pcar:=9200;
    castells(dosde8).pcar:=9820;
    castells(quatrede9).pcar:=11120;
    castells(tresde10fm).pcar:=13220;
end inic_puntuacio;



---------------------------------------------------------
-- Calculem el total de punts per 1 colla donada       --
---------------------------------------------------------

function total_punts (ident_fet: in ident; accio_feta: accio; long: in integer) return natural is

total: natural;  -- Aixo es el que retornarem: el total de punts
longitud: integer;  -- La anirem decrementant per saber els castells que ens falten per comprovar

begin
    total:=0; longitud:=long;
    
    if (long<3) then -- Si el castells fets son 3 o menys, no cal buscar els de max. puntuacio
                     -- aixi optimitzem el proces sense haver de fer grans busquedes.
	for j in 0..long loop
	        if (accio_feta(j)='d') then
	    	    total:=total+castells(ident_fet(j)).pdesc;
	    	else
		    total:=total+castells(ident_fet(j)).pcar;
		end if;
		longitud:=longitud-1;
	end loop;
    else -- Bucar els castells fets amb max. puntuacio i sumar
	for i in reverse dosde7..tresde10fm loop  -- Els identificadors de castell van de - puntuacio a +
                                                -- aixi que busquem en ordre invers
	    for j in 0..long loop  -- Mira cada castell fet
		if (i=ident_fet(j)) then
	    	    if (accio_feta(j)='d') then
	    		total:=total+castells(i).pdesc;
	    	    else
			total:=total+castells(i).pcar;
		    end if;
		    longitud:=longitud-1;  -- Hem trobat 1 castell, decrementem els que ens falten
		end if;
	    end loop;
	    if (long-longitud=3) then  -- Si hem trobat ja 3 castells, deixem de buscar
    	       exit;
	    end if;
	end loop;
    end if;

    return total;
end total_punts;



---------------------------------------------------------
-- Programa Principal                                  --
---------------------------------------------------------

begin
    put_line("Processant...... ");
    inic_puntuacio(castells);
    open(actuacio, in_file, "castells.txt");
    create(resultat, out_file, "resultat.txt");
    linea:=0;
    while not(end_of_file(actuacio)) loop
	-- Obtenim nom de la colla
	bucle:=0; linea:=linea+1;
	get(actuacio, nom_colla(bucle));
	while (nom_colla(bucle)/= ':') and (bucle<40) and (not(end_of_line(actuacio))) loop
    	    put(resultat, nom_colla(bucle));
	    bucle:=bucle+1;
	    get(actuacio, nom_colla(bucle));
	end loop;
	if (end_of_line(actuacio)) and (nom_colla(bucle)/= ':') then  -- S'ha escrit nomes el nom de la colla sense ':'
	    raise incompleta;
	elsif (nom_colla(bucle)/= ':') then  -- L'ultim caracter trobat ha de ser ':', sino vol dir que el nom es
	    raise llarg;                     -- massa llarg
	end if;

	if (bucle=0) then  -- Evita que comprovi la ultima linea en blanc
	    exit;
	end if;

	-- Pasem a comprobar quins castells ha fet
      -- Les taules ident_fet i accio_feta van relacionades segons la posicio:
      -- el castell ident_fet(0) ha sigut accio_feta(0); el castell 'x' ha sigut carregat
      -- el castell ident_fet(1) ha sigut accio_feta(1); el castell 'y' ha sigut descarregat
	bucle:=0;
	while (not(end_of_line(actuacio))) and bucle<5 loop
    	    get(actuacio, ident_fet(bucle)); -- Identificador
	    get(actuacio, accio_feta(bucle));
	    while (accio_feta(bucle)=' ') loop  -- ignorar espais en blanc
		get(actuacio, accio_feta(bucle)); -- Carregat / Descarregat	    
	    end loop;
	    if (accio_feta(bucle)/='c') and (accio_feta(bucle)/='d') then
		raise accio_erronea;
	    end if;
	    bucle:=bucle+1;
	end loop;
	bucle:=bucle-1;
	total:=total_punts(ident_fet, accio_feta, bucle);  -- Calculem el total de punts per aquesta colla
	put(resultat, " ");                                -- i ho fiquem al arxiu de sortida
	put(resultat, total, width=>5);
	put(resultat, " punts");new_line(resultat);
	skip_line(actuacio);
    end loop;
    
    close(resultat);
    close(actuacio);
    put_line("Finalitzat!");


    exception
	when llarg => put("ERROR al arxiu d'entrada [LINEA ");put(linea, width=>3);put_line("]");
		      put_line("El nom de la colla es massa llarg.");
		      close(resultat);close(actuacio);
	when incompleta => put("ERROR al arxiu d'entrada [LINEA ");put(linea, width=>3);put_line("]");
			   put_line("La linea d'entrada esta incompleta.");close(resultat);close(actuacio);
	when accio_erronea => put("ERROR al arxiu d'entrada [LINEA ");put(linea, width=>3);put_line("]");
			      put_line("Si el castell ha sigut carregat, s'ha d'indicar amb una 'c'.");
			      put_line("Si el castell ha sigut descarregat, s'ha d'indicar amb una 'd'.");
			      close(resultat);close(actuacio);
	when data_error => put("ERROR al arxiu d'entrada [LINEA ");put(linea, width=>3);put_line("]");
			   put_line("Ha escrit dades incorrectes, s'ha deixat dades per indicar,");
			   put_line("o no ha utilitzat una estructura correcte.");
			   close(resultat);close(actuacio);
	when name_error => put_line("ERROR: noms d'arxius incorrectes");
	when use_error => put_line("ERROR: no hi ha permis per fer us dels arxius");
	when device_error => put_line("ERROR: el dispositiu no es troba en bon estat");
	
end blanco_p2;